FROM rayproject/autoscaler:0.8.7-gpu

RUN apt-get update \
    && apt-get install -y --no-install-recommends \
        software-properties-common \
        curl \
        pkg-config \
        unzip \
        vim \
        fish \
        clang \
        wget \
        psmisc

RUN wget https://github.com/Kitware/CMake/releases/download/v3.15.2/cmake-3.15.2.tar.gz \
    && tar -zxvf cmake-3.15.2.tar.gz \
    && cd cmake-3.15.2 \
    && ./bootstrap \
    && make \
    && make install \
    && cmake --version \
    && cd .. \
    && rm -rf cmake-3.15.2 cmake-3.15.2.tar.gz

COPY requirements.txt /root/requirements.txt
COPY minispiel /root/minispiel
WORKDIR /root
RUN conda update -n base -c defaults conda \
    && conda init bash \
    && pip install --upgrade pip setuptools \
    && pip install -r /root/requirements.txt \
    && ./minispiel/scripts/build_and_run_tests.sh \
    && touch build/python/__init__.py \
    && mkdir pvc

ENV PYTHONPATH="/root/build/python"
