from abc import ABC, abstractmethod
from algorithms.utils.types import SpielAction


class ZeroNode(ABC):
    def __init__(self, action: SpielAction, prior: float):
        self.action = action
        self.prior = prior
        self.explore_count = 0
        self.total_value = 0.0
        self.bellman_action = -1  # type: SpielAction

    @abstractmethod
    def uct_value(self, parent_explore_count: int, uct: float):
        raise NotImplementedError

    @abstractmethod
    def puct_value(self, parent_explore_count: int, uct: float):
        raise NotImplementedError

    @abstractmethod
    def sort_key(self):
        raise NotImplementedError

    @abstractmethod
    def best_child(self):
        raise NotImplementedError

    @abstractmethod
    def children_str(self, state=None):
        raise NotImplementedError

    @abstractmethod
    def to_str(self, state=None):
        raise NotImplementedError

