from abc import ABC, abstractmethod
from typing import Sized


class ReplayBuffer(ABC, Sized):
    def __init__(self, buffer_capacity: int):
        self._replay_buffer_capacity = buffer_capacity
        self._next_entry_index = 0

    @abstractmethod
    def add(self, element) -> None:
        raise NotImplementedError

    @abstractmethod
    def sample(self, num_samples, k=None):
        raise NotImplementedError

    @abstractmethod
    def get_num_actions(self) -> int:
        raise NotImplementedError

