from typing import NamedTuple, Tuple

from algorithms.abstract.extractor import Extractor
from algorithms.utils.types import QueueName


class Params(NamedTuple):
    extractor: Extractor
    rep_input_shape: Tuple[int, int, int]
    rep_output_shape: Tuple[int, int, int]
    pred_input_shape: Tuple[int, int, int]
    dyn_input_shape: Tuple[int, int, int]
    dyn_output_shape: Tuple[int, int, int]
    flat_input_size: int
    train_queue_name: str
    play_queue_name: str
    eval_queue_name: str
    backup_weights_queue: str
    backup_buffer_queue: str
    backup_log_queue: str
    log_name: str
    models_name: str
    num_actions: int
    num_players: int
    algorithm: str
    local: str
    buffer_capacity: int
    service: str
    num_train_workers: int
    num_play_workers: int
    num_eval_workers: int
    num_points: int
    num_chex: int
    num_die: int
    image_width: int
    pass_action: int
    num_hidden_weights: int
    num_hidden_layers: int
    hidden_layer_activation: str
    hidden_layer_initializer: str
    hidden_state_activation: str
    hidden_state_initializer: str
    use_batchnorm: bool
    load_weights_name: str
    learning_rate: float
    l2_regularization: float
    num_simulations: int
    device: str
    k: int
    train_mode: str
    num_epochs: int
    batch_size: int
    num_rounds: int
    num_self_play: int
    self_play_agent: str
    num_eval_skill: int
    num_eval_dyn: int
    num_train_cpus: int
    num_train_gpus: float
    num_play_cpus: int
    num_play_gpus: float
    num_eval_cpus: int
    num_eval_gpus: float
    scale_gradient: bool
    chance_player_id: int = 2
    terminal_player_id: int = 3
    delete_queues: bool = True
