// Copyright 2019 DeepMind Technologies Ltd. All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include "minispiel/games/nannon.h"

#include <algorithm>
#include <random>

#include "minispiel/spiel.h"
#include "minispiel/tests/basic_tests.h"

namespace open_spiel {
namespace nannon {
namespace {

namespace testing = open_spiel::testing;

//void BasicLegalMoveTest() {
//  std::shared_ptr<const Game> game = LoadGame("nannon");
//  std::unique_ptr<State> state = game->NewInitialState();
//  NannonState* nstate = static_cast<NannonState*>(state.get());
//  nstate->SetState(kXPlayerId, {1},
//                              {1, 1},
//                              {0, 0},
//                              {{1, 1, 0, 0, 0, 0}, {0, 0, 0, 0, 1, 1}});
//  std::cout << nstate->ToString();
//  std::vector<Action> legal_actions = nstate->LegalActions();
//  SPIEL_CHECK_EQ(legal_actions.size(), 1);
//  open_spiel::nannon::CheckerMove checker_move =
//      nstate->SpielMoveToCheckerMove(kOPlayerId, legal_actions[0]);
//  SPIEL_CHECK_EQ(checker_move.pos, 1);
//  SPIEL_CHECK_EQ(checker_move.num, 1);
//}
//
//bool CheckStateEquality(NannonState* nstate, std::vector<std::vector<int>> expected_board,
//        std::vector<int> expected_home, std::vector<int> expected_scores) {
//    SPIEL_CHECK_EQ(expected_board[0], nstate->board(0));
//    SPIEL_CHECK_EQ(expected_board[1], nstate->board(1));
//    SPIEL_CHECK_EQ(expected_home[0], nstate->home(0));
//    SPIEL_CHECK_EQ(expected_home[1], nstate->home(1));
//    SPIEL_CHECK_EQ(expected_scores[0], nstate->score(0));
//    SPIEL_CHECK_EQ(expected_scores[1], nstate->score(1));
//
//}
//    void CaptureTestPlayerX() {
//        std::cout << "\n----------------\n";
//        std::shared_ptr<const Game> game = LoadGame("nannon");
//        std::unique_ptr<State> state = game->NewInitialState();
//        NannonState* nstate = static_cast<NannonState*>(state.get());
//        nstate->SetState(kXPlayerId, {3},
//                         {1, 1},
//                         {0, 0},
//                         {{1, 1, 0, 0, 0, 0}, {0, 0, 0, 1, 0, 1}});
//        std::cout << nstate->ToString();
//        std::vector<Action> legal_actions = nstate->LegalActions();
//        SPIEL_CHECK_EQ(legal_actions.size(), 3);
//        SPIEL_CHECK_EQ(legal_actions[0], 0);
//        SPIEL_CHECK_EQ(legal_actions[1], 1);
//        SPIEL_CHECK_EQ(legal_actions[2], kHomePos);
//        std::string expected_action_str = "0 - 6/3*";
//        std::string actual_action_str;
//        open_spiel::nannon::CheckerMove checker_move =
//                nstate->SpielMoveToCheckerMove(kXPlayerId, legal_actions[0]);
//        SPIEL_CHECK_EQ(checker_move.pos, 0);
//        SPIEL_CHECK_EQ(checker_move.num, 3);
//        SPIEL_CHECK_EQ(checker_move.hit, true);
//        actual_action_str = nstate->ActionToString(kXPlayerId, legal_actions[0]);
//        SPIEL_CHECK_EQ(expected_action_str, actual_action_str);
//
//
//        expected_action_str = "1 - 5/2";
//        checker_move = nstate->SpielMoveToCheckerMove(kXPlayerId, legal_actions[1]);
//        SPIEL_CHECK_EQ(checker_move.pos, 1);
//        SPIEL_CHECK_EQ(checker_move.num, 3);
//        SPIEL_CHECK_EQ(checker_move.hit, false);
//        actual_action_str = nstate->ActionToString(kXPlayerId, legal_actions[1]);
//        SPIEL_CHECK_EQ(expected_action_str, actual_action_str);
//
//        expected_action_str = "6 - Home/4";
//        checker_move = nstate->SpielMoveToCheckerMove(kXPlayerId, legal_actions[2]);
//        SPIEL_CHECK_EQ(checker_move.pos, kHomePos);
//        SPIEL_CHECK_EQ(checker_move.num, 3);
//        SPIEL_CHECK_EQ(checker_move.hit, false);
//        actual_action_str = nstate->ActionToString(kXPlayerId, legal_actions[2]);
//        SPIEL_CHECK_EQ(expected_action_str, actual_action_str);
//
//        nstate->ApplyAction(legal_actions[0]);
//        std::vector<std::vector<int>> expected_board = {{0, 1, 0, 1, 0, 0}, {0, 0, 0, 0, 0, 1}};
//        std::vector<int> expected_home = {1, 2};
//        std::vector<int> expected_scores = {0, 0};
//        CheckStateEquality(nstate, expected_board, expected_home, expected_scores);
//    }
//
//    void CaptureTestPlayerO() {
//        std::cout << "\n----------------\n";
//        std::shared_ptr<const Game> game = LoadGame("nannon");
//        std::unique_ptr<State> state = game->NewInitialState();
//        NannonState* nstate = static_cast<NannonState*>(state.get());
//        nstate->SetState(kOPlayerId, {5},
//                         {1, 1},
//                         {0, 0},
//                         {{1, 0, 1, 0, 0, 0}, {0, 0, 0, 1, 0, 1}});
//        std::cout << nstate->ToString();
//        std::vector<Action> legal_actions = nstate->LegalActions();
//        SPIEL_CHECK_EQ(legal_actions.size(), 3);
//        SPIEL_CHECK_EQ(legal_actions[0], 3);
//        SPIEL_CHECK_EQ(legal_actions[1], 5);
//        SPIEL_CHECK_EQ(legal_actions[2], kHomePos);
//
//        std::string expected_action_str = "3 - 4/Off";
//        std::string actual_action_str;
//        open_spiel::nannon::CheckerMove checker_move =
//                nstate->SpielMoveToCheckerMove(kOPlayerId, legal_actions[0]);
//        SPIEL_CHECK_EQ(checker_move.pos, 3);
//        SPIEL_CHECK_EQ(checker_move.num, 5);
//        SPIEL_CHECK_EQ(checker_move.hit, false);
//        actual_action_str = nstate->ActionToString(kOPlayerId, legal_actions[0]);
//        SPIEL_CHECK_EQ(expected_action_str, actual_action_str);
//
//        expected_action_str = "5 - 6/1*";
//        checker_move = nstate->SpielMoveToCheckerMove(kOPlayerId, legal_actions[1]);
//        SPIEL_CHECK_EQ(checker_move.pos, 5);
//        SPIEL_CHECK_EQ(checker_move.num, 5);
//        SPIEL_CHECK_EQ(checker_move.hit, true);
//        actual_action_str = nstate->ActionToString(kOPlayerId, legal_actions[1]);
//        SPIEL_CHECK_EQ(expected_action_str, actual_action_str);
//
//        expected_action_str = "6 - Home/2";
//        checker_move = nstate->SpielMoveToCheckerMove(kOPlayerId, legal_actions[2]);
//        SPIEL_CHECK_EQ(checker_move.pos, kHomePos);
//        SPIEL_CHECK_EQ(checker_move.num, 5);
//        SPIEL_CHECK_EQ(checker_move.hit, false);
//        actual_action_str = nstate->ActionToString(kOPlayerId, legal_actions[2]);
//        SPIEL_CHECK_EQ(expected_action_str, actual_action_str);
//
//        nstate->ApplyAction(legal_actions[0]);
//        std::vector<std::vector<int>> expected_board = {{1, 0, 1, 0, 0, 0}, {0, 0, 0, 0, 0, 1}};
//        std::vector<int> expected_home = {1, 1};
//        std::vector<int> expected_scores = {0, 1};
//        CheckStateEquality(nstate, expected_board, expected_home, expected_scores);
//
//        nstate->UndoAction(kOPlayerId, legal_actions[0]);
//        expected_board = {{1, 0, 1, 0, 0, 0}, {0, 0, 0, 1, 0, 1}};
//        expected_home = {1, 1};
//        expected_scores = {0, 0};
//        CheckStateEquality(nstate, expected_board, expected_home, expected_scores);
//
//        nstate->ApplyAction(legal_actions[1]);
//        expected_board = {{0, 0, 1, 0, 0, 0}, {1, 0, 0, 1, 0, 0}};
//        expected_home = {2, 1};
//        expected_scores = {0, 0};
//        CheckStateEquality(nstate, expected_board, expected_home, expected_scores);
//
//        nstate->UndoAction(kOPlayerId, legal_actions[1]);
//        expected_board = {{1, 0, 1, 0, 0, 0}, {0, 0, 0, 1, 0, 1}};
//        expected_home = {1, 1};
//        expected_scores = {0, 0};
//        CheckStateEquality(nstate, expected_board, expected_home, expected_scores);
//
//        nstate->ApplyAction(legal_actions[2]);
//        expected_board = {{1, 0, 1, 0, 0, 0}, {0, 1, 0, 1, 0, 1}};
//        expected_home = {1, 0};
//        expected_scores = {0, 0};
//        CheckStateEquality(nstate, expected_board, expected_home, expected_scores);
//
//        nstate->UndoAction(kOPlayerId, legal_actions[2]);
//        expected_board = {{1, 0, 1, 0, 0, 0}, {0, 0, 0, 1, 0, 1}};
//        expected_home = {1, 1};
//        expected_scores = {0, 0};
//        CheckStateEquality(nstate, expected_board, expected_home, expected_scores);
//    }
//
//    void ScoreTest() {
//        std::cout << "\n----------------\n";
//        std::shared_ptr<const Game> game = LoadGame("nannon");
//        std::unique_ptr<State> state = game->NewInitialState();
//        NannonState* nstate = static_cast<NannonState*>(state.get());
//        nstate->SetState(kXPlayerId, {2},
//                         {0, 0},
//                         {2, 2},
//                         {{0, 0, 0, 0, 1, 0}, {0, 0, 0, 1, 0, 0}});
//        std::cout << nstate->ToString();
//        std::vector<Action> legal_actions = nstate->LegalActions();
//        SPIEL_CHECK_EQ(legal_actions.size(), 1);
//        SPIEL_CHECK_EQ(legal_actions[0], 4);
//        nstate->ApplyAction(legal_actions[0]);
//    }

//    void ParamTest() {
//        std::shared_ptr<const Game> game = LoadGame("nannon");
//        std::unique_ptr<State> state = game->NewInitialState();
//        NannonState* nstate = static_cast<NannonState*>(state.get());
//        nstate->SetState(kOPlayerId, {6},
//                         {1, 1},
//                         {0, 1},
//                         {{1, 0, 0, 0, 0, 0, 1, 0}, {0, 0, 0, 0, 0, 0, 0, 1}});
//        std::cout << nstate->ToString();
//        std::vector<Action> legal_actions = nstate->LegalActions();
//        SPIEL_CHECK_EQ(legal_actions.size(), 1);
//        SPIEL_CHECK_EQ(legal_actions[0], 4);
//        nstate->ApplyAction(legal_actions[0]);
//
//    }

    void RollTestDie(NannonState *nstate, int die) {
        die = die - 1;
        nstate->ApplyAction(die);
    }

    void PrintObs(NannonState *nstate, std::string s) {
        std::vector<double> obs = nstate->State::ObservationTensor(0);
        std::cout << "\n" << s << "\n[";
        for (std::vector<double>::const_iterator i = obs.begin(); i != obs.end(); ++i)
            std::cout << *i << ' ';
        std::cout << "]";
        std::cout.flush();
    }

    void ObservationTensorTest() {
        std::shared_ptr<const Game> game = LoadGame("nannon");
        std::unique_ptr<State> state = game->NewInitialState();
        NannonState* nstate = static_cast<NannonState*>(state.get());
        std::string s;
        nstate->SetState(kXPlayerId, {2},
                         {1, 1},
                         {0, 0},
                         {{1, 1, 0, 0, 0, 0,}, {0, 0, 0, 0, 1, 1}},
                         3);
        nstate->ApplyAction(0);
        open_spiel::nannon::RollTestDie(nstate, 1);
        s = "x|-xx-oo|o player: o, die=1";
        open_spiel::nannon::PrintObs(nstate, s);

        nstate->ApplyAction(4);
        s = "x|-xxo-o|o player: chance, die=-1";
        open_spiel::nannon::PrintObs(nstate, s);
        open_spiel::nannon::RollTestDie(nstate, 3);
        s = "x|-xxo-o|o player: x, die=3";
        open_spiel::nannon::PrintObs(nstate, s);

        nstate->ApplyAction(2);
        open_spiel::nannon::RollTestDie(nstate, 6);
        s = "x|-x-o-x|oo player: o, die=6";
        open_spiel::nannon::PrintObs(nstate, s);

        nstate->ApplyAction(3);
        open_spiel::nannon::RollTestDie(nstate, 5);
        s = "x|-x---x|oo player: x, die=5";
        open_spiel::nannon::PrintObs(nstate, s);

        nstate->ApplyAction(6);
        open_spiel::nannon::RollTestDie(nstate, 6);
        s = " |-x--xx|oo player: o, die=6";
        open_spiel::nannon::PrintObs(nstate, s);

        nstate->ApplyAction(6);
        open_spiel::nannon::RollTestDie(nstate, 2);
        s = " |ox--xx|o player: x, die=2";
        open_spiel::nannon::PrintObs(nstate, s);

        nstate->ApplyAction(6);
        open_spiel::nannon::RollTestDie(nstate, 2);
        s = " |ox--xx|o player: x, die=2";
        open_spiel::nannon::PrintObs(nstate, s);
    }

}  // namespace
}  // namespace nannon
}  // namespace open_spiel

int main(int argc, char** argv) {
  open_spiel::testing::LoadGameTest("nannon");
//  open_spiel::nannon::BasicLegalMoveTest();
//  open_spiel::nannon::CaptureTestPlayerX();
//  open_spiel::nannon::CaptureTestPlayerO();
  open_spiel::nannon::ObservationTensorTest();
}
